import { AbstractModelDB, Effect, ModelValue, ModelSchema, QueryParams } from "@canvas-js/modeldb";
import "./worker.js";
export interface ModelDBOptions {
    path?: string;
    models: ModelSchema;
}
export declare class ModelDB extends AbstractModelDB {
    private readonly worker;
    private readonly wrappedDB;
    static initialize({ path, models }: ModelDBOptions): Promise<ModelDB>;
    private constructor();
    close(): Promise<void>;
    apply(effects: Effect[]): Promise<void>;
    get<T extends ModelValue>(modelName: string, key: string): Promise<T | null>;
    iterate(modelName: string): AsyncIterable<ModelValue>;
    count(modelName: string): Promise<number>;
    query<T extends ModelValue = ModelValue>(modelName: string, query?: QueryParams): Promise<T[]>;
}
